using System;
using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;

//  Auto Genitalia Expansion Plugin by Saking55
//
//  A modified version of the Belly Bulger Plugin by Captain Varghoss.
//

namespace Saking55
{
    public class AutoGenExpansion : MVRScript
    {
        protected JSONStorableBool isActive;
        protected JSONStorableBool clampMorph;
        protected JSONStorableBool debugMode;
        protected JSONStorableString uiFocusTarget;
        protected JSONStorableFloat uiBulgeMult;
        protected JSONStorableFloat uiMinBulgeDistMult;
        protected JSONStorableFloat uiBulge1Mult;
        protected JSONStorableFloat uiBulge2Mult;
        protected JSONStorableFloat uiBulge3Mult;
        
        protected JSONStorableFloat uiCurrentDepth;
        protected JSONStorableString helpText;
        protected JSONStorableString helpText2;
        protected JSONStorableString helpText3;

        protected JSONStorableFloat uiTargetOffsetX;
        protected JSONStorableFloat uiTargetOffsetY;
        protected JSONStorableFloat uiTargetOffsetZ;
        
        protected JSONStorableString helpText_Offset;

        protected JSONStorableFloat smoothingFactor;
        protected JSONStorableString filterName;
        protected JSONStorableBool filterNameActive;

        public static float tempFloatA = 1.0f;
        public static float tempFloatV = 1.0f;
        public static float tempFloat = 1.0f;

        private static FreeControllerV3 chestController;
        private static DAZMorph morph2;
        private static DAZMorph morph3;
        private static DAZMorph morph4;
        private static DAZMorph morph5;
        private static DAZMorph morph6;
        private static DAZMorph morph7;
        private static DAZMorph morph8;

        private static Atom person;

        CollisionTriggerEventHandler triggerEvtHdl1;
        CollisionTriggerEventHandler triggerEvtHdl2;
        CollisionTriggerEventHandler triggerEvtHdl3;

        String targetAtomName;
        String selectedTarget;

        private CollisionTrigger triggerVag;
        private CollisionTrigger triggerVagD;
        private CollisionTrigger triggerVagDD;

        private Collider temp;
        private Collider colDistTarget = null;
        Dictionary<UnityEngine.Collider,bool> colResult;
        long lastColUpdate = 0;

        float yVelocity = 0.0f;
        float yVelocity2 = 0.0f;
        float yVelocity3 = 0.0f;
        float distance, oldDist, tempDist, minDist = 10f;

        bool notReset = true;
        bool morphsLoaded = true;
        
        protected JSONStorableBool analActive;
        protected JSONStorableBool vaginalActive;

        public override void Init()
        {
            try
            {

                // Active Toggle
                isActive = new JSONStorableBool("isActive", true);
                RegisterBool(isActive);
                var toggle = CreateToggle(isActive);
                toggle.label = "Active";	


                colResult = new Dictionary<UnityEngine.Collider, bool>();;

                JSONStorableAction ToggleActive = new JSONStorableAction("Toggle Gen Expansion", () =>
                {
                    isActive.val = !isActive.val;
                });
                RegisterAction(ToggleActive);
				
				helpText = new JSONStorableString("Helptext", "\n<b>Auto Gen Expansion</b>\n\nAutomatically selects the collinding object and apply morphs to Person.\n");
                UIDynamic helpTextfield = CreateTextField(helpText, false);
                helpTextfield.height = 210f;


                clampMorph = new JSONStorableBool("clampMorph", true);
                RegisterBool(clampMorph);
                var toggle2_ = CreateToggle(clampMorph);
                toggle2_.label = "Limit Morphs";

                debugMode = new JSONStorableBool("debugDepth", false);
                RegisterBool(debugMode);
                var toggle3_ = CreateToggle(debugMode);
                toggle3_.label = "Manual Depth";


				uiFocusTarget = new JSONStorableString( "TargetObject","\n<b>Target:</b> None");
				UIDynamic targetText = CreateTextField(uiFocusTarget, true);
				targetText.height = 100f;

                uiBulgeMult = _createSlider("Gen Expansion Multiplier", 1f, 0.0f, 3.0f, rightSide:false, constrain:false);
                uiMinBulgeDistMult = _createSlider("Min Expansion Dist Multiplier", 5f, 0.0f, 5.0f, rightSide:false, constrain:false);
                uiCurrentDepth = _createSlider("Current Depth", 1f, 0.0f, 1.0f, rightSide:false, constrain:false);
                smoothingFactor = _createSlider("Morph Smoothing", 0.05f, 0.0f, 1.0f, rightSide:false, constrain:false);

                var btn = CreateButton("Reset Morphs", false);
                btn.button.onClick.AddListener(() => { ResetMorphs(); });

                // Toggle Anal Expansion
                analActive = new JSONStorableBool("analActive", false);
                RegisterBool(analActive);
                var toggle2 = CreateToggle(analActive);
                toggle2.label = "Anal Exp. Enabled";	

                JSONStorableAction ToggleAnalActive = new JSONStorableAction("Toggle Anal Expansion", () =>
                {
                    analActive.val = !analActive.val;
                });
                RegisterAction(ToggleAnalActive);

                // Toggle Vaginal Expansion
                vaginalActive = new JSONStorableBool("vaginalActive", true);
                RegisterBool(vaginalActive);
                var toggle3 = CreateToggle(vaginalActive);
                toggle3.label = "Vaginal Exp. Enabled";	

                JSONStorableAction ToggleVaginalActive = new JSONStorableAction("Toggle Vaginal Expansion", () =>
                {
                    vaginalActive.val = !vaginalActive.val;
                });
                RegisterAction(ToggleVaginalActive);
				
                // Per morph multiplier reducers
                helpText2 = new JSONStorableString("Helptext2", "\n<b>Morph Adjustments</b>\n\nUse these morphs to reduce Multiplier on individual morphs.");
                UIDynamic helpTextfield2 = CreateTextField(helpText2, true);
                helpTextfield2.height = 200f;

                uiBulge1Mult = _createSlider("Anal Morph Amount Mult", 1f, 0.0f, 3.0f, rightSide:true, constrain:false);
                uiBulge2Mult = _createSlider("Vaginal Morph Amount Mult", 1f, 0.0f, 3.0f, rightSide:true, constrain:false);
                uiBulge3Mult = _createSlider("Vag Open", 1f, 0.0f, 3.0f, rightSide:true, constrain:false);

                // Target Atom name filtering
                helpText3 = new JSONStorableString("Helptext3", "\n<b>Target Atom Name Filtering</b>\n\nUse the input below to filter which Atom should be used by the plugin. i.e. Person, Dildo...\nOptional, use if the plugin doesn't select the desired target automatically.");
                UIDynamic helpTextfield3 = CreateTextField(helpText3, true);
                helpTextfield3.height = 280f;

                filterNameActive = new JSONStorableBool("filterNameActive",false);
                RegisterBool(filterNameActive);
                var toggleFilter = CreateToggle(filterNameActive,true);
                toggleFilter.label = "Filter Atom Name";	

                JSONStorableAction ToggleNameFilterActive = new JSONStorableAction("Toggle Name Filter", () =>
                {
                    filterNameActive.val = !filterNameActive.val;
                });
                RegisterAction(ToggleNameFilterActive);

                filterName = new JSONStorableString( "filterString","Person");
				UIDynamic nameFilterText = CreateTextInput(filterName,true);
				nameFilterText.height = 10f;

                helpText_Offset = new JSONStorableString("helpText_Offset", "\n<b>Target Offset</b>\nOffsets the target position");
                UIDynamic helpTextfield_Offset = CreateTextField(helpText_Offset, false);
                helpTextfield_Offset.height = 120f;
                uiTargetOffsetX = _createSlider("Target Offset X", 0f, -1.0f, 1.0f, false, true, false);
                uiTargetOffsetY = _createSlider("Target Offset Y", 0f, -1.0f, 1.0f, false, true, false);
                uiTargetOffsetZ = _createSlider("Target Offset Z", 0f, -1.0f, 1.0f, false, true, false);


            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void Start()
        {
            try
            {
                person = containingAtom;
                
                
                if (person != null)
                {
                    triggerVag = (containingAtom.GetStorableByID("VaginaTrigger") as CollisionTrigger);
                    triggerVagD = (containingAtom.GetStorableByID("DeepVaginaTrigger") as CollisionTrigger);
                    triggerVagDD = (containingAtom.GetStorableByID("DeeperVaginaTrigger") as CollisionTrigger);

                    triggerVag.triggerEnabledJSON.val = true;
                    triggerVagD.triggerEnabledJSON.val = true;
                    triggerVagDD.triggerEnabledJSON.val = true;

                    triggerEvtHdl1 = triggerVag.GetComponent(typeof(CollisionTriggerEventHandler)) as CollisionTriggerEventHandler;
                    triggerEvtHdl2 = triggerVagD.GetComponent(typeof(CollisionTriggerEventHandler)) as CollisionTriggerEventHandler;
                    triggerEvtHdl3 = triggerVagDD.GetComponent(typeof(CollisionTriggerEventHandler)) as CollisionTriggerEventHandler;

                    chestController = person.GetStorableByID("chestControl") as FreeControllerV3;
                    ResetMorphs();
                }

                

                
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        private void ResetMorphs()
        {
            if (notReset) {
                JSONStorable js = person.GetStorableByID("geometry");
                DAZCharacterSelector dcs = js as DAZCharacterSelector;
                GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;

                if (morphUI != null)
                {

                        try {
                            morph4 = morphUI.GetMorphByDisplayName("AutoGenExp Anal 1");
                            morph4.Reset();
                            morph8 = morphUI.GetMorphByDisplayName("AutoGenExp Anal 2");
                            morph8.Reset();
                            morph3 = morphUI.GetMorphByDisplayName("AutoGenExp Anal 3");
                            morph3.Reset();


                            morph5 = morphUI.GetMorphByDisplayName("AutoGenExp Vag 1");
                            morph5.Reset();
                            morph6 = morphUI.GetMorphByDisplayName("AutoGenExp Vag 2");
                            morph6.Reset();
                            morph7 = morphUI.GetMorphByDisplayName("AutoGenExp Vag 3");
                            morph7.Reset();
                        }catch(Exception e){ 
                            SuperController.LogError("Morphs not found!\n Disabling AutoGenExpansion.");
                            morphsLoaded = false;
                        }


                        // morph8 = morphUI.GetMorphByDisplayName("b4-p8-1");
                        // morph8.Reset();
                }
                notReset = false;
            }
        }

        void FixedUpdate()
        {
            if (isActive.val && morphsLoaded)
            {
                try
                {
                    // helpText4.val = "<b>Collisions:</b>";
                    targetAtomName = "None";

                    UpdateCollisionsDict();

                    foreach (KeyValuePair<Collider, bool> pair in colResult)
                    {
                        selectedTarget = (pair.Key.attachedRigidbody.GetComponentInParent(typeof(Atom)) as Atom).name;
                        if (selectedTarget.Equals(containingAtom.name))
                        {
                            selectedTarget = "None";
                        } else {
                            if (filterNameActive.val && (selectedTarget.ToLower().Contains(filterName.val.ToLower())) || !filterNameActive.val){
                                distance = Vector3.Distance(chestController.followWhenOff.position, pair.Key.attachedRigidbody.position);

                                if (distance < minDist){
                                    temp = pair.Key;
                                    minDist = distance;
                                    targetAtomName = selectedTarget;
                                }
                            }
                        }
                    }

                    if (targetAtomName == "None"){
                        colDistTarget = null;
                        minDist = 10f;
                    }

                    if (colDistTarget == null){
                        colDistTarget = temp;
                    } else {
                        var offset = new Vector3(uiTargetOffsetX.val, uiTargetOffsetY.val, uiTargetOffsetZ.val);
                        // By calculating the rotation Quaternion, align the offset to the target's local coordinate system.
                        oldDist = Vector3.Distance(chestController.followWhenOff.position, 
                            colDistTarget.attachedRigidbody.position + colDistTarget.attachedRigidbody.rotation * offset);
                        tempDist = Vector3.Distance(chestController.followWhenOff.position, 
                            temp.attachedRigidbody.position + temp.attachedRigidbody.rotation * offset);

                        // oldDist = Vector3.Distance(chestController.followWhenOff.position, colDistTarget.attachedRigidbody.position);
                        // tempDist = Vector3.Distance(chestController.followWhenOff.position, temp.attachedRigidbody.position);
                    
                        if (tempDist < oldDist)
                            minDist = tempDist;
                        else 
                            minDist = oldDist;

                    }

                    // uiFocusTarget.val = "\n<b>Target:</b> "+ targetAtomName  + " dist: " + minDist;
                    uiFocusTarget.val = "\n<b>Target:</b> "+ targetAtomName ; 
                    
                    // if (morph2 != null)
                    // {
                        notReset = true;
                        if (targetAtomName.Equals("None")){
                            tempFloatV = Mathf.SmoothDamp(tempFloatV, 1f, ref yVelocity2, smoothingFactor.val);
                            tempFloatA = Mathf.SmoothDamp(tempFloatA, 1f, ref yVelocity3, smoothingFactor.val);
                            tempFloat = Mathf.SmoothDamp(tempFloat, 1f, ref yVelocity, smoothingFactor.val);
                        }
                        else {
                            // uiFocusTarget.val += "\n TempA "+ tempFloatA + "  TempV "+ tempFloatV;
                            if (analActive.val)     
                                tempFloatA = Mathf.SmoothDamp(tempFloatA, remapp(minDist, 0.2f, 0.35f, 0f, 0.7f), ref yVelocity2, smoothingFactor.val);
                            else 
                                tempFloatA = Mathf.SmoothDamp(tempFloatA, 1f, ref yVelocity2, smoothingFactor.val);
                            
                            if (vaginalActive.val)  
                                tempFloatV = Mathf.SmoothDamp(tempFloatV, remapp(minDist, 0.2f, 0.35f, 0f, 0.7f), ref yVelocity3, smoothingFactor.val);
                            else 
                                tempFloatV = Mathf.SmoothDamp(tempFloatV, 1f, ref yVelocity3, smoothingFactor.val);
                            
                            tempFloat = Mathf.SmoothDamp(tempFloat, remapp(minDist,  0.2f, 0.35f, 0f, 0.7f), ref yVelocity, smoothingFactor.val);

                        }

                        if (debugMode.val){
                            tempFloat = uiCurrentDepth.val;
                            if (analActive.val)    tempFloatA = uiCurrentDepth.val;
                            if (vaginalActive.val) tempFloatV = uiCurrentDepth.val;
                        
                        }
                         calcUpdateMorph(morph3, tempFloatA, 0.2f, uiBulge1Mult,3f);
                         calcUpdateMorph(morph4, tempFloatA, 0.2f, uiBulge1Mult,3f);
                         calcUpdateMorph(morph8, tempFloatA, 0.2f, uiBulge1Mult,0.3f);
                         calcUpdateMorph(morph5, tempFloatV, 0.1f, uiBulge3Mult,0.3f);
                         calcUpdateMorph(morph6, tempFloatV, 0.2f, uiBulge2Mult,1f);
                         calcUpdateMorph(morph7, tempFloatV, 0.2f, uiBulge2Mult,2f);
                    // }
                    if (!debugMode.val) uiCurrentDepth.val = tempFloat;
                    minDist = 10f;
                }
                catch (Exception e)
                {
                    SuperController.LogError("Exception caught: " + e);
                }
            }
            else { ResetMorphs(); }
        }


        private float remapp(float val, float from1, float to1, float from2, float to2)
        {
            return (val - from1) / (to1 - from1) * (to2 - from2) + from2;
        }

        void OnDestroy() {
            ResetMorphs();
        }

        void OnDisable()
        {
            ResetMorphs();
        }


        private void UpdateCollisionsDict(){
            var now = DateTime.Now.Ticks / TimeSpan.TicksPerMillisecond;
            if (triggerVag.trigger.active || triggerVagD.trigger.active || triggerVagDD.trigger.active){
                // while collisions are happening, keeps track of all collisions
                colResult = triggerEvtHdl1.collidingWithDictionary
                            .Concat(triggerEvtHdl2.collidingWithDictionary)
                            .Concat(triggerEvtHdl3.collidingWithDictionary).Concat(colResult)
                            .GroupBy(d => d.Key).ToDictionary(d => d.Key, d => d.First().Value);
                lastColUpdate = now;

            } else if (now > lastColUpdate + 500){
                // only dumps collisions after 500 ms of no collision
                colResult.Clear();
            }
            
            var itemsToRemove = colResult.Where(f => f.Key.attachedRigidbody == null).ToArray();
            foreach (var item in itemsToRemove){
                colResult.Remove(item.Key);
                // SuperController.LogError("Removed");
            }

            
        }

        private void calcUpdateMorph(DAZMorph targetMorph, float distance, float eachDist0, JSONStorableFloat eachBulgeMult,float max = 1f)
        {
            targetMorph.morphValue =
                Mathf.Max((1.0f - distance / (eachDist0 * uiMinBulgeDistMult.val)) * uiBulgeMult.val * eachBulgeMult.val, 0.0f);
            if (clampMorph.val) targetMorph.morphValue = Mathf.Clamp(targetMorph.morphValue, 0f, max);
        }

        private JSONStorableFloat _createSlider(string sliderName, float defaultValue, float minValue, float maxValue,
            bool constrain = true, bool interactable = true, bool rightSide=false)
        {
            JSONStorableFloat ret = new JSONStorableFloat(sliderName, defaultValue, minValue, maxValue, constrain, interactable);
            RegisterFloat(ret);
            CreateSlider(ret, rightSide);
            return ret;
        }




        public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false)
        {
            var textfield = CreateTextField(jss, rightSide);
            textfield.height = 20f;
            textfield.backgroundColor = Color.white;
            var input = textfield.gameObject.AddComponent<InputField>();
            var rect = input.GetComponent<RectTransform>().sizeDelta = new Vector2(1f, 0.4f);
            input.textComponent = textfield.UItext;
            jss.inputField = input;
            return textfield;
        }

    }
}

